Index: binaries/data/mods/public/gui/common/functions_utility_list.js
===================================================================
--- binaries/data/mods/public/gui/common/functions_utility_list.js	(Revision 14461)
+++ binaries/data/mods/public/gui/common/functions_utility_list.js	(Arbeitskopie)
@@ -10,15 +10,15 @@
 // Remove the item at the given index (pos) from the given list object (objectName).
 function removeItem (objectName, pos)
 {
-	if (getGUIObjectByName (objectName) == null)
+	if (Engine.GetGUIObjectByName (objectName) == null)
 		Engine.Console_Write ("removeItem(): " + objectName + " not found.");
 
-	var list = getGUIObjectByName (objectName).list;
-	var selected = getGUIObjectByName (objectName).selected;
+	var list = Engine.GetGUIObjectByName (objectName).list;
+	var selected = Engine.GetGUIObjectByName (objectName).selected;
 
 	list.splice(pos, 1);
 
-	getGUIObjectByName (objectName).list = list;
+	Engine.GetGUIObjectByName (objectName).list = list;
 
 	// It's important that we update the selection *after*
 	//  we've committed the changes to the list.
@@ -26,12 +26,12 @@
 	// Update the selected so the same element remains selected.
 	if (selected == pos)
 	{
-		getGUIObjectByName (objectName).selected = -1;
+		Engine.GetGUIObjectByName (objectName).selected = -1;
 	}
 	else
 	if (selected > pos)
 	{
-		getGUIObjectByName (objectName).selected = selected - 1;
+		Engine.GetGUIObjectByName (objectName).selected = selected - 1;
 	}
 }
 
@@ -40,15 +40,15 @@
 // Add the item at the given index (pos) to the given list object (objectName) with the given value (value).
 function addItem (objectName, pos, value)
 {
-	if (getGUIObjectByName (objectName) == null)
+	if (Engine.GetGUIObjectByName (objectName) == null)
 		Engine.Console_Write ("addItem(): " + objectName + " not found.");
 
-	var list = getGUIObjectByName (objectName).list;
-	var selected = getGUIObjectByName (objectName).selected;
+	var list = Engine.GetGUIObjectByName (objectName).list;
+	var selected = Engine.GetGUIObjectByName (objectName).selected;
 
 	list.splice (pos, 0, value);
 
-	getGUIObjectByName (objectName).list = list;
+	Engine.GetGUIObjectByName (objectName).list = list;
 
 	// It's important that we update the selection *after*
 	//  we've committed the changes to the list.
@@ -56,7 +56,7 @@
 	// Update the selected so the same element remains selected.
 	if (selected >= pos)
 	{
-		getGUIObjectByName (objectName).selected = selected + 1;
+		Engine.GetGUIObjectByName (objectName).selected = selected + 1;
 	}
 }
 
@@ -65,14 +65,14 @@
 // Adds an element to the end of the list
 function pushItem (objectName, value)
 {
-	if (getGUIObjectByName (objectName) == null)
+	if (Engine.GetGUIObjectByName (objectName) == null)
 		Engine.Console_Write ("pushItem(): " + objectName + " not found.");
 
-	var list = getGUIObjectByName (objectName).list;
+	var list = Engine.GetGUIObjectByName (objectName).list;
 	list.push (value);
-	getGUIObjectByName (objectName).list = list;
+	Engine.GetGUIObjectByName (objectName).list = list;
 	// Point to the new item.
-	getGUIObjectByName(objectName).selected = getNumItems(objectName)-1;
+	Engine.GetGUIObjectByName(objectName).selected = getNumItems(objectName)-1;
 }
 
 // ====================================================================
@@ -80,15 +80,15 @@
 // Removes the last element
 function popItem (objectName)
 {
-	if (getGUIObjectByName (objectName) == null)
+	if (Engine.GetGUIObjectByName (objectName) == null)
 		Engine.Console_Write ("popItem(): " + objectName + " not found.");
 
-	var selected = getGUIObjectByName (objectName).selected;
+	var selected = Engine.GetGUIObjectByName (objectName).selected;
 	removeItem(objectName, getNumItems(objectName)-1);
 
 	if (selected == getNumItems(objectName)-1)
 	{
-		getGUIObjectByName(objectName).selected = -1;
+		Engine.GetGUIObjectByName(objectName).selected = -1;
 	}
 }
 
@@ -97,10 +97,10 @@
 // Retrieves the number of elements in the list
 function getNumItems (objectName)
 {
-	if (getGUIObjectByName (objectName) == null)
+	if (Engine.GetGUIObjectByName (objectName) == null)
 		Engine.Console_Write ("getNumItems(): " + objectName + " not found.");
 
-	var list = getGUIObjectByName(objectName).list;
+	var list = Engine.GetGUIObjectByName(objectName).list;
 	return list.length;
 }
 
@@ -109,10 +109,10 @@
 // Retrieves the value of the item at 'pos'
 function getItemValue (objectName, pos)
 {
-	if (getGUIObjectByName (objectName) == null)
+	if (Engine.GetGUIObjectByName (objectName) == null)
 		Engine.Console_Write ("getItemValue(): " + objectName + " not found.");
 
-	var list = getGUIObjectByName(objectName).list;
+	var list = Engine.GetGUIObjectByName(objectName).list;
 	return list[pos];
 }
 
@@ -121,13 +121,13 @@
 // Retrieves the value of the currently selected item
 function getCurrItemValue (objectName)
 {
-	if (getGUIObjectByName (objectName) == null)
+	if (Engine.GetGUIObjectByName (objectName) == null)
 		Engine.Console_Write ("getCurrItemValue(): " + objectName + " not found.");
 
-	if (getGUIObjectByName(objectName).selected == -1)
+	if (Engine.GetGUIObjectByName(objectName).selected == -1)
 		return "";
-	var list = getGUIObjectByName(objectName).list;
-	return list[getGUIObjectByName(objectName).selected];
+	var list = Engine.GetGUIObjectByName(objectName).list;
+	return list[Engine.GetGUIObjectByName(objectName).selected];
 }
 
 // ====================================================================
@@ -136,14 +136,14 @@
 // already in the list).
 function setCurrItemValue (objectName, string)
 {
-	if (getGUIObjectByName(objectName) == null) {
+	if (Engine.GetGUIObjectByName(objectName) == null) {
 		Engine.Console_Write ("setCurrItemValue(): " + objectName + " not found.");
 		return -1;
 	}
 
-	if (getGUIObjectByName(objectName).selected == -1)
+	if (Engine.GetGUIObjectByName(objectName).selected == -1)
 		return -1;	// Return -1 if nothing selected.
-	var list = getGUIObjectByName(objectName).list;
+	var list = Engine.GetGUIObjectByName(objectName).list;
 	// Seek through list.
 	for (var ctr = 0; ctr < list.length; ctr++)
 	{
@@ -151,7 +151,7 @@
 		if (list[ctr] == string)
 		{
 			// Point selected to this item.
-			getGUIObjectByName(objectName).selected = ctr;
+			Engine.GetGUIObjectByName(objectName).selected = ctr;
 			return ctr;	// Return position of item.
 		}
 	}
Index: binaries/data/mods/public/gui/common/functions_utility_test.js
===================================================================
--- binaries/data/mods/public/gui/common/functions_utility_test.js	(Revision 14461)
+++ binaries/data/mods/public/gui/common/functions_utility_test.js	(Arbeitskopie)
@@ -1,6 +1,6 @@
 function updateOrbital()
 {
-	if( !getGUIObjectByName( 'arena' ).hidden )
+	if( !Engine.GetGUIObjectByName( 'arena' ).hidden )
 	{
 		g_ballx += g_balldx;
 		g_bally += g_balldy;
@@ -36,7 +36,7 @@
 		g_balldx -= force * vect_x;
 		g_balldy -= force * vect_y;
 
-		var ball = getGUIObjectByName('ball');
+		var ball = Engine.GetGUIObjectByName('ball');
 		var r=5;
 		ball.size = new GUISize(g_ballx-r, g_bally-r, g_ballx+r, g_bally+r);
 	}
Index: binaries/data/mods/public/gui/common/functions_utility.js
===================================================================
--- binaries/data/mods/public/gui/common/functions_utility.js	(Revision 14461)
+++ binaries/data/mods/public/gui/common/functions_utility.js	(Arbeitskopie)
@@ -20,7 +20,7 @@
 // Get list of XML files in pathname with recursion, excepting those starting with _
 function getXMLFileList(pathname)
 {
-	var files = buildDirEntList(pathname, "*.xml", true);
+	var files = Engine.BuildDirEntList(pathname, "*.xml", true);
 
 	var result = [];
 
@@ -45,7 +45,7 @@
 // Get list of JSON files in pathname
 function getJSONFileList(pathname)
 {
-	var files = buildDirEntList(pathname, "*.json", false);
+	var files = Engine.BuildDirEntList(pathname, "*.json", false);
 
 	// Remove the path and extension from each name, since we just want the filename
 	files = [ n.substring(pathname.length, n.length-5) for each (n in files) ];
@@ -61,7 +61,7 @@
 {
 	var data = {};
 
-	var rawData = readFile(pathname);
+	var rawData = Engine.ReadFile(pathname);
 	if (!rawData)
 	{
 		error("Failed to read file: "+pathname);
@@ -139,7 +139,7 @@
 function parseJSONFromDataFile(filename)
 {
 	var path = "simulation/data/"+filename;
-	var rawData = readFile(path);
+	var rawData = Engine.ReadFile(path);
 	if (!rawData)
 		error("Failed to read file: "+path);
 
Index: binaries/data/mods/public/gui/common/functions_global_object.js
===================================================================
--- binaries/data/mods/public/gui/common/functions_global_object.js	(Revision 14461)
+++ binaries/data/mods/public/gui/common/functions_global_object.js	(Arbeitskopie)
@@ -6,28 +6,62 @@
 // *******************************************
 // messageBox
 // *******************************************
-// @params:     int mbWidth, int mbHeight, string mbMessage, string mbTitle, int mbMode, arr mbButtonCaptions, arr mbButtonsCode
+// @params:     int mbWidth, int mbHeight, string mbMessage, string mbTitle, int mbMode, arr mbButtonCaptions, function mbBtnCode, var mbCallbackArgs
 // @return:     void
 // @desc:       Displays a new modal message box.
 // *******************************************
 
-function messageBox (mbWidth, mbHeight, mbMessage, mbTitle, mbMode, mbButtonCaptions, mbButtonsCode)
+
+// We want to pass callback functions for the different buttons in a convenient way.
+// Because passing functions accross compartment boundaries is a pain, we just store them here together with some optional arguments.
+// The messageBox page will return the code of the pressed button and the according function will be called.
+var g_messageBoxBtnFunctions = [];
+var g_messageBoxCallbackArgs = []; 
+
+var g_messageBoxCallbackFunction = function(btnCode)
 {
+	if (btnCode !== undefined && g_messageBoxBtnFunctions[btnCode])
+	{
+		if (g_messageBoxCallbackArgs[btnCode])
+			g_messageBoxBtnFunctions[btnCode](g_messageBoxCallbackArgs[btnCode]);
+		else
+			g_messageBoxBtnFunctions[btnCode]();
+	}
 
-	Engine.PushGuiPage("page_msgbox.xml", {
+	g_messageBoxBtnFunctions  = [];
+	g_messageBoxCallbackArgs = [];
+}
+
+function messageBox (mbWidth, mbHeight, mbMessage, mbTitle, mbMode, mbButtonCaptions, mbBtnCode, mbCallbackArgs)
+{
+	if (g_messageBoxBtnFunctions.length != 0)
+	{
+		warn("A messagebox was called when a previous callback function is still set, aborting!");
+		return;	
+	}
+
+	g_messageBoxBtnFunctions = mbBtnCode;
+	if (mbCallbackArgs)
+		g_messageBoxCallbackArgs = mbCallbackArgs;
+
+	var initData = {
 		width: mbWidth,
 		height: mbHeight,
 		message: mbMessage,
 		title: mbTitle,
 		mode: mbMode,
 		buttonCaptions: mbButtonCaptions,
-		buttonCode: mbButtonsCode
-	});
+	}
+	if (mbBtnCode)
+		initData.callback = "g_messageBoxCallbackFunction";
+		
+
+	Engine.PushGuiPage("page_msgbox.xml", initData);
 }
 
 // ====================================================================
 
 function updateFPS()
 {	
-	getGUIObjectByName("fpsCounter").caption = "FPS: " + getFPS();
+	Engine.GetGUIObjectByName("fpsCounter").caption = "FPS: " + Engine.GetFPS();
 }
Index: build/premake/premake4.lua
===================================================================
--- build/premake/premake4.lua	(Revision 14461)
+++ build/premake/premake4.lua	(Arbeitskopie)
@@ -733,6 +733,9 @@
 		"opengl",
 		"boost",
 	}
+	if not _OPTIONS["without-audio"] then
+		table.insert(extern_libs, "openal")
+	end
 	setup_static_lib_project("gui", source_dirs, extern_libs, {})
 
 
Index: source/tools/atlas/GameInterface/ActorViewer.cpp
===================================================================
--- source/tools/atlas/GameInterface/ActorViewer.cpp	(Revision 14461)
+++ source/tools/atlas/GameInterface/ActorViewer.cpp	(Arbeitskopie)
@@ -67,7 +67,7 @@
 		MeshManager(ColladaManager),
 		SkeletonAnimManager(ColladaManager),
 		UnitManager(),
-		Simulation2(&UnitManager, &Terrain),
+		Simulation2(&UnitManager, g_ScriptRuntime, &Terrain),
 		ObjectManager(MeshManager, SkeletonAnimManager, Simulation2),
 		LOSTexture(Simulation2),
 		TerritoryTexture(Simulation2)
Index: source/tools/atlas/GameInterface/GameLoop.cpp
===================================================================
--- source/tools/atlas/GameInterface/GameLoop.cpp	(Revision 14461)
+++ source/tools/atlas/GameInterface/GameLoop.cpp	(Arbeitskopie)
@@ -39,7 +39,6 @@
 #include "ps/Profile.h"
 #include "ps/GameSetup/Paths.h"
 #include "renderer/Renderer.h"
-#include "scripting/ScriptingHost.h"
 
 using namespace AtlasMessage;
 
@@ -329,7 +328,6 @@
 
 	// Clean up
 	AtlasView::DestroyViews();
-	ScriptingHost::FinalShutdown();
 	AtlasMessage::g_MessagePasser = NULL;
 
 	return true;
Index: source/tools/atlas/GameInterface/Handlers/MiscHandlers.cpp
===================================================================
--- source/tools/atlas/GameInterface/Handlers/MiscHandlers.cpp	(Revision 14461)
+++ source/tools/atlas/GameInterface/Handlers/MiscHandlers.cpp	(Arbeitskopie)
@@ -25,6 +25,7 @@
 #include "graphics/CinemaTrack.h"
 #include "graphics/GameView.h"
 #include "gui/GUIManager.h"
+#include "gui/GUI.h"
 #include "lib/external_libraries/libsdl.h"
 #include "lib/sysdep/cpu.h"
 #include "maths/MathUtil.h"
@@ -33,7 +34,6 @@
 #include "ps/GameSetup/Config.h"
 #include "ps/GameSetup/GameSetup.h"
 #include "renderer/Renderer.h"
-#include "scripting/ScriptingHost.h"
 
 extern void (*Atlas_GLSwapBuffers)(void* context);
 
@@ -149,12 +149,12 @@
 
 MESSAGEHANDLER(JavaScript)
 {
-	g_ScriptingHost.ExecuteScript(*msg->command, L"Atlas");
+	g_GUI->GetActiveGUI()->GetScriptInterface()->LoadGlobalScript(L"Atlas", *msg->command);
 }
 
 MESSAGEHANDLER(GuiSwitchPage)
 {
-	g_GUI->SwitchPage(*msg->page, CScriptVal());
+	g_GUI->SwitchPage(*msg->page, NULL, JSVAL_VOID);
 }
 
 MESSAGEHANDLER(GuiMouseButtonEvent)
Index: source/graphics/tests/test_LOSTexture.h
===================================================================
--- source/graphics/tests/test_LOSTexture.h	(Revision 14461)
+++ source/graphics/tests/test_LOSTexture.h	(Arbeitskopie)
@@ -19,6 +19,7 @@
 
 #include "graphics/LOSTexture.h"
 #include "lib/timer.h"
+#include "scriptinterface/ScriptInterface.h"
 #include "simulation2/Simulation2.h"
 
 class TestLOSTexture : public CxxTest::TestSuite
@@ -26,7 +27,7 @@
 public:
 	void test_basic()
 	{
-		CSimulation2 sim(NULL, NULL);
+		CSimulation2 sim(NULL, ScriptInterface::CreateRuntime(), NULL);
 		CLOSTexture tex(sim);
 
 		const ssize_t size = 8;
@@ -60,7 +61,7 @@
 
 	void test_perf_DISABLED()
 	{
-		CSimulation2 sim(NULL, NULL);
+		CSimulation2 sim(NULL, ScriptInterface::CreateRuntime(), NULL);
 		CLOSTexture tex(sim);
 
 		const ssize_t size = 257;
Index: source/graphics/scripting/JSInterface_GameView.cpp
===================================================================
--- source/graphics/scripting/JSInterface_GameView.cpp	(Revision 14461)
+++ source/graphics/scripting/JSInterface_GameView.cpp	(Arbeitskopie)
@@ -24,7 +24,7 @@
 #include "scriptinterface/ScriptInterface.h"
 
 #define IMPLEMENT_BOOLEAN_SCRIPT_SETTING(NAME) \
-bool JSI_GameView::Get##NAME##Enabled(void* UNUSED(cbdata)) \
+bool JSI_GameView::Get##NAME##Enabled(ScriptInterface::CxPrivate* UNUSED(pCxPrivate)) \
 { \
 	if (!g_Game || !g_Game->GetView()) \
 	{ \
@@ -34,7 +34,7 @@
 	return g_Game->GetView()->Get##NAME##Enabled(); \
 } \
 \
-void JSI_GameView::Set##NAME##Enabled(void* UNUSED(cbdata), bool Enabled) \
+void JSI_GameView::Set##NAME##Enabled(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), bool Enabled) \
 { \
 	if (!g_Game || !g_Game->GetView()) \
 	{ \
Index: source/graphics/scripting/JSInterface_GameView.h
===================================================================
--- source/graphics/scripting/JSInterface_GameView.h	(Revision 14461)
+++ source/graphics/scripting/JSInterface_GameView.h	(Arbeitskopie)
@@ -20,11 +20,11 @@
 #define INCLUDED_JSINTERFACE_GAMEVIEW
 
 #include "ps/CStr.h"
-class ScriptInterface;
+#include "scriptinterface/ScriptInterface.h"
 
 #define DECLARE_BOOLEAN_SCRIPT_SETTING(NAME) \
-	bool Get##NAME##Enabled(void* cbdata); \
-	void Set##NAME##Enabled(void* cbdata, bool Enabled);
+	bool Get##NAME##Enabled(ScriptInterface::CxPrivate* pCxPrivate); \
+	void Set##NAME##Enabled(ScriptInterface::CxPrivate* pCxPrivate, bool Enabled);
 
 namespace JSI_GameView
 {
Index: source/graphics/MapGenerator.h
===================================================================
--- source/graphics/MapGenerator.h	(Revision 14461)
+++ source/graphics/MapGenerator.h	(Arbeitskopie)
@@ -120,11 +120,11 @@
 	bool LoadScripts(const std::wstring& libraryName);
 	
 	// callbacks for script functions
-	static bool LoadLibrary(void* cbdata, std::wstring name);
-	static void ExportMap(void* cbdata, CScriptValRooted data);
-	static void SetProgress(void* cbdata, int progress);
-	static void MaybeGC(void* cbdata);
-	static std::vector<std::string> GetCivData(void* cbdata);
+	static bool LoadLibrary(ScriptInterface::CxPrivate* pCxPrivate, std::wstring name);
+	static void ExportMap(ScriptInterface::CxPrivate* pCxPrivate, CScriptValRooted data);
+	static void SetProgress(ScriptInterface::CxPrivate* pCxPrivate, int progress);
+	static void MaybeGC(ScriptInterface::CxPrivate* pCxPrivate);
+	static std::vector<std::string> GetCivData(ScriptInterface::CxPrivate* pCxPrivate);
 
 	std::set<std::wstring> m_LoadedLibraries;
 	shared_ptr<ScriptInterface::StructuredClone> m_MapData;
Index: source/graphics/MapGenerator.cpp
===================================================================
--- source/graphics/MapGenerator.cpp	(Revision 14461)
+++ source/graphics/MapGenerator.cpp	(Arbeitskopie)
@@ -147,16 +147,15 @@
 	return m_MapData;
 }
 
-bool CMapGeneratorWorker::LoadLibrary(void* cbdata, std::wstring name)
+bool CMapGeneratorWorker::LoadLibrary(ScriptInterface::CxPrivate* pCxPrivate, std::wstring name)
 {
-	CMapGeneratorWorker* self = static_cast<CMapGeneratorWorker*>(cbdata);
-
+	CMapGeneratorWorker* self = static_cast<CMapGeneratorWorker*>(pCxPrivate->pCBData);
 	return self->LoadScripts(name);
 }
 
-void CMapGeneratorWorker::ExportMap(void* cbdata, CScriptValRooted data)
+void CMapGeneratorWorker::ExportMap(ScriptInterface::CxPrivate* pCxPrivate, CScriptValRooted data)
 {
-	CMapGeneratorWorker* self = static_cast<CMapGeneratorWorker*>(cbdata);
+	CMapGeneratorWorker* self = static_cast<CMapGeneratorWorker*>(pCxPrivate->pCBData);
 
 	// Copy results
 	CScopeLock lock(self->m_WorkerMutex);
@@ -164,22 +163,22 @@
 	self->m_Progress = 0;
 }
 
-void CMapGeneratorWorker::SetProgress(void* cbdata, int progress)
+void CMapGeneratorWorker::SetProgress(ScriptInterface::CxPrivate* pCxPrivate, int progress)
 {
-	CMapGeneratorWorker* self = static_cast<CMapGeneratorWorker*>(cbdata);
+	CMapGeneratorWorker* self = static_cast<CMapGeneratorWorker*>(pCxPrivate->pCBData);
 
 	// Copy data
 	CScopeLock lock(self->m_WorkerMutex);
 	self->m_Progress = progress;
 }
 
-void CMapGeneratorWorker::MaybeGC(void* cbdata)
+void CMapGeneratorWorker::MaybeGC(ScriptInterface::CxPrivate* pCxPrivate)
 {
-	CMapGeneratorWorker* self = static_cast<CMapGeneratorWorker*>(cbdata);
+	CMapGeneratorWorker* self = static_cast<CMapGeneratorWorker*>(pCxPrivate->pCBData);
 	self->m_ScriptInterface->MaybeGC();
 }
 
-std::vector<std::string> CMapGeneratorWorker::GetCivData(void* UNUSED(cbdata))
+std::vector<std::string> CMapGeneratorWorker::GetCivData(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
 {
 	VfsPath path(L"civs/");
 	VfsPaths pathnames;
Index: source/test_setup.cpp
===================================================================
--- source/test_setup.cpp	(Revision 14461)
+++ source/test_setup.cpp	(Arbeitskopie)
@@ -116,7 +116,7 @@
 
 namespace
 {
-	void script_TS_FAIL(void*, std::wstring msg)
+	void script_TS_FAIL(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring msg)
 	{
 		TS_FAIL(msg);
 	}
Index: source/gui/scripting/JSInterface_IGUIObject.cpp
===================================================================
--- source/gui/scripting/JSInterface_IGUIObject.cpp	(Revision 14461)
+++ source/gui/scripting/JSInterface_IGUIObject.cpp	(Arbeitskopie)
@@ -86,11 +86,11 @@
 	if (propName.substr(0, 2) == "on")
 	{
 		CStr eventName (CStr(propName.substr(2)).LowerCase());
-		std::map<CStr, JSObject**>::iterator it = e->m_ScriptHandlers.find(eventName);
+		std::map<CStr, CScriptValRooted>::iterator it = e->m_ScriptHandlers.find(eventName);
 		if (it == e->m_ScriptHandlers.end())
 			*vp = JSVAL_NULL;
 		else
-			*vp = OBJECT_TO_JSVAL(*(it->second));
+			*vp = it->second.get();
 		return JS_TRUE;
 	}
 
@@ -182,7 +182,8 @@
 				*vp = OBJECT_TO_JSVAL(obj); // root it
 				try
 				{
-				#define P(x, y, z) g_ScriptingHost.SetObjectProperty_Double(obj, #z, area.x.y)
+					ScriptInterface* pScriptInterface = ScriptInterface::GetScriptInterfaceAndCBData(cx)->pScriptInterface;
+				#define P(x, y, z) pScriptInterface->SetProperty(OBJECT_TO_JSVAL(obj), #z, area.x.y, false, true)
 					P(pixel,	left,	left);
 					P(pixel,	top,	top);
 					P(pixel,	right,	right);
@@ -481,7 +482,8 @@
 				GUI<CClientArea>::GetSetting(e, propName, area);
 
 				JSObject* obj = JSVAL_TO_OBJECT(*vp);
-				#define P(x, y, z) area.x.y = (float)g_ScriptingHost.GetObjectProperty_Double(obj, #z)
+				ScriptInterface* pScriptInterface = ScriptInterface::GetScriptInterfaceAndCBData(cx)->pScriptInterface;
+				#define P(x, y, z) pScriptInterface->GetProperty(OBJECT_TO_JSVAL(obj), #z, area.x.y)
 					P(pixel,	left,	left);
 					P(pixel,	top,	top);
 					P(pixel,	right,	right);
@@ -603,9 +605,9 @@
 	return JS_TRUE;
 }
 
-void JSI_IGUIObject::init()
+void JSI_IGUIObject::init(ScriptInterface& scriptInterface)
 {
-	g_ScriptingHost.DefineCustomObjectType(&JSI_class, construct, 1, JSI_props, JSI_methods, NULL, NULL);
+	scriptInterface.DefineCustomObjectType(&JSI_class, construct, 1, JSI_props, JSI_methods, NULL, NULL);
 }
 
 JSBool JSI_IGUIObject::toString(JSContext* cx, uintN argc, jsval* vp)
@@ -654,7 +656,6 @@
 JSBool JSI_IGUIObject::getComputedSize(JSContext* cx, uintN argc, jsval* vp)
 {
 	UNUSED2(argc);
-
 	IGUIObject* e = (IGUIObject*)JS_GetInstancePrivate(cx, JS_THIS_OBJECT(cx, vp), &JSI_IGUIObject::JSI_class, NULL);
 	if (!e)
 		return JS_FALSE;
@@ -665,10 +666,11 @@
 	JSObject* obj = JS_NewObject(cx, NULL, NULL, NULL);
 	try
 	{
-		g_ScriptingHost.SetObjectProperty_Double(obj, "left", size.left);
-		g_ScriptingHost.SetObjectProperty_Double(obj, "right", size.right);
-		g_ScriptingHost.SetObjectProperty_Double(obj, "top", size.top);
-		g_ScriptingHost.SetObjectProperty_Double(obj, "bottom", size.bottom);
+		ScriptInterface* pScriptInterface = ScriptInterface::GetScriptInterfaceAndCBData(cx)->pScriptInterface;
+		pScriptInterface->SetProperty(OBJECT_TO_JSVAL(obj), "left", size.left, false, true);
+		pScriptInterface->SetProperty(OBJECT_TO_JSVAL(obj), "right", size.right, false, true);
+		pScriptInterface->SetProperty(OBJECT_TO_JSVAL(obj), "top", size.top, false, true);
+		pScriptInterface->SetProperty(OBJECT_TO_JSVAL(obj), "bottom", size.bottom, false, true);
 	}
 	catch (PSERROR_Scripting_ConversionFailed&)
 	{
Index: source/gui/scripting/JSInterface_IGUIObject.h
===================================================================
--- source/gui/scripting/JSInterface_IGUIObject.h	(Revision 14461)
+++ source/gui/scripting/JSInterface_IGUIObject.h	(Arbeitskopie)
@@ -15,7 +15,7 @@
  * along with 0 A.D.  If not, see <http://www.gnu.org/licenses/>.
  */
 
-#include "scripting/ScriptingHost.h"
+#include "scriptinterface/ScriptInterface.h"
 
 #ifndef INCLUDED_JSI_IGUIOBJECT
 #define INCLUDED_JSI_IGUIOBJECT
@@ -32,7 +32,7 @@
 	JSBool focus(JSContext* cx, uintN argc, jsval* vp);
 	JSBool blur(JSContext* cx, uintN argc, jsval* vp);
 	JSBool getComputedSize(JSContext* cx, uintN argc, jsval* vp);
-	void init();
+	void init(ScriptInterface& scriptInterface);
 }
 
 #endif
Index: source/gui/scripting/JSInterface_GUITypes.cpp
===================================================================
--- source/gui/scripting/JSInterface_GUITypes.cpp	(Revision 14461)
+++ source/gui/scripting/JSInterface_GUITypes.cpp	(Arbeitskopie)
@@ -110,7 +110,12 @@
 
 	try
 	{
-#define SIDE(side) buffer += ToPercentString(g_ScriptingHost.GetObjectProperty_Double(JS_THIS_OBJECT(cx, vp), #side), g_ScriptingHost.GetObjectProperty_Double(JS_THIS_OBJECT(cx, vp), "r"#side));
+		ScriptInterface* pScriptInterface = ScriptInterface::GetScriptInterfaceAndCBData(cx)->pScriptInterface;
+		double val, valr;
+#define SIDE(side) \
+		pScriptInterface->GetProperty(JS_THIS_VALUE(cx, vp), #side, val); \
+		pScriptInterface->GetProperty(JS_THIS_VALUE(cx, vp), "r"#side, valr); \
+		buffer += ToPercentString(val, valr);
 		SIDE(left);
 		buffer += " ";
 		SIDE(top);
@@ -191,12 +196,12 @@
 {
 	UNUSED2(argc);
 
-	jsdouble r, g, b, a;
-	if (!JS_ValueToNumber(cx, g_ScriptingHost.GetObjectProperty(JS_THIS_OBJECT(cx, vp), "r"), &r)) return JS_FALSE;
-	if (!JS_ValueToNumber(cx, g_ScriptingHost.GetObjectProperty(JS_THIS_OBJECT(cx, vp), "g"), &g)) return JS_FALSE;
-	if (!JS_ValueToNumber(cx, g_ScriptingHost.GetObjectProperty(JS_THIS_OBJECT(cx, vp), "b"), &b)) return JS_FALSE;
-	if (!JS_ValueToNumber(cx, g_ScriptingHost.GetObjectProperty(JS_THIS_OBJECT(cx, vp), "a"), &a)) return JS_FALSE;
-
+	double r, g, b, a;
+	ScriptInterface* pScriptInterface = ScriptInterface::GetScriptInterfaceAndCBData(cx)->pScriptInterface;
+	pScriptInterface->GetProperty(JS_THIS_VALUE(cx, vp), "r", r);
+	pScriptInterface->GetProperty(JS_THIS_VALUE(cx, vp), "g", g);
+	pScriptInterface->GetProperty(JS_THIS_VALUE(cx, vp), "b", b);
+	pScriptInterface->GetProperty(JS_THIS_VALUE(cx, vp), "a", a);
 	char buffer[256];
 	// Convert to integers, to be compatible with the GUI's string SetSetting
 	snprintf(buffer, 256, "%d %d %d %d",
@@ -261,9 +266,10 @@
 	UNUSED2(argc);
 
 	int32 x, y, buttons;
-	if (!JS_ValueToECMAInt32(cx, g_ScriptingHost.GetObjectProperty(JS_THIS_OBJECT(cx, vp), "x"), &x)) return JS_FALSE;
-	if (!JS_ValueToECMAInt32(cx, g_ScriptingHost.GetObjectProperty(JS_THIS_OBJECT(cx, vp), "y"), &y)) return JS_FALSE;
-	if (!JS_ValueToECMAInt32(cx, g_ScriptingHost.GetObjectProperty(JS_THIS_OBJECT(cx, vp), "buttons"), &buttons)) return JS_FALSE;
+	ScriptInterface* pScriptInterface = ScriptInterface::GetScriptInterfaceAndCBData(cx)->pScriptInterface;
+	pScriptInterface->GetProperty(JS_THIS_VALUE(cx, vp), "x", x);
+	pScriptInterface->GetProperty(JS_THIS_VALUE(cx, vp), "y", y);
+	pScriptInterface->GetProperty(JS_THIS_VALUE(cx, vp), "buttons", buttons);
 
 	char buffer[256];
 	snprintf(buffer, 256, "%d %d %d", x, y, buttons);
@@ -273,9 +279,9 @@
 
 
 // Initialise all the types at once:
-void JSI_GUITypes::init()
+void JSI_GUITypes::init(ScriptInterface& scriptInterface)
 {
-	g_ScriptingHost.DefineCustomObjectType(&JSI_GUISize::JSI_class,  JSI_GUISize::construct,  1, JSI_GUISize::JSI_props,  JSI_GUISize::JSI_methods,  NULL, NULL);
-	g_ScriptingHost.DefineCustomObjectType(&JSI_GUIColor::JSI_class, JSI_GUIColor::construct, 1, JSI_GUIColor::JSI_props, JSI_GUIColor::JSI_methods, NULL, NULL);
-	g_ScriptingHost.DefineCustomObjectType(&JSI_GUIMouse::JSI_class, JSI_GUIMouse::construct, 1, JSI_GUIMouse::JSI_props, JSI_GUIMouse::JSI_methods, NULL, NULL);
+	scriptInterface.DefineCustomObjectType(&JSI_GUISize::JSI_class,  JSI_GUISize::construct,  1, JSI_GUISize::JSI_props,  JSI_GUISize::JSI_methods,  NULL, NULL);
+	scriptInterface.DefineCustomObjectType(&JSI_GUIColor::JSI_class, JSI_GUIColor::construct, 1, JSI_GUIColor::JSI_props, JSI_GUIColor::JSI_methods, NULL, NULL);
+	scriptInterface.DefineCustomObjectType(&JSI_GUIMouse::JSI_class, JSI_GUIMouse::construct, 1, JSI_GUIMouse::JSI_props, JSI_GUIMouse::JSI_methods, NULL, NULL);
 }
Index: source/gui/scripting/JSInterface_GUITypes.h
===================================================================
--- source/gui/scripting/JSInterface_GUITypes.h	(Revision 14461)
+++ source/gui/scripting/JSInterface_GUITypes.h	(Arbeitskopie)
@@ -15,7 +15,7 @@
  * along with 0 A.D.  If not, see <http://www.gnu.org/licenses/>.
  */
 
-#include "scripting/ScriptingHost.h"
+#include "scriptinterface/ScriptInterface.h"
 
 #ifndef INCLUDED_JSI_GUITYPES
 #define INCLUDED_JSI_GUITYPES
@@ -38,7 +38,7 @@
 
 namespace JSI_GUITypes
 {
-	void init();
+	void init(ScriptInterface& scriptInterface);
 }
 
 #endif
